/*
 * mmap sample driver を叩くテストプログラム
 *
 * [ドライバの準備]
 *  # make clean; make 
 *  # sudo insmod ./sample.ko
 *  # dmesg |tail
 *  # sudo mknod --mode=666 /dev/sample c 260 0
 *
 * [テストプログラムの準備]
 *  # cc app.c && ./a.out
 *  
 * [終了]
 *  # sudo rmmod sample
 *  # sudo rm /dev/sample
 *
 */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/mman.h>

#define DEVFILE	"/dev/sample"

int main(void)
{
	int fd;
	unsigned char *ptr;
	int map_size = 64;
	int i;

	fd = open(DEVFILE, O_RDWR);
	if (fd < 0) {
		perror("open");
		exit(1);
	}

	ptr = mmap(0, map_size, PROT_READ, MAP_SHARED, fd, 0);
	if (ptr == MAP_FAILED) {
		perror("mmap");
		exit(1);
	}

	for (i = 0 ; i < map_size ; i++) {
		printf("%02x ", ptr[i]);
	}
	printf("\n");

	munmap(ptr, map_size);
	close(fd);

	return 0;
}

